#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
# -----------------------------------------------------------------------------------------------
# THIS PLUGIN WAS DEVELOPED AND TESTED UNDER WINDOWS VISTA ONLY AND MAY OR MAY NOT WORK ON A MAC. 
# -----------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
# -----------------------------------------------------------------------------------------------
#    Name:	Area of Faces By Material
#      By:	sdmitch
#   Usage:	Plugins>SDM Tools>Face Tool>Area of Faces By Material
#		 Note:	
#    Date:	Nov 2015
#------------------------------------------------------------------------------------------------
require 'sketchup'
# ------------------  MENU SETUP ---------------------- #
unless $sdm_tools_menu
	$sdm_tools_menu = UI.menu("Plugins").add_submenu("SDM Tools")
	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Edge Tool")
	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Face Tool")
	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("CorG Tool")
	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Misc Tool")
end
unless file_loaded?(__FILE__)
	$sdm_Face_tools.add_item("Area of Faces By Material") { SDM::Area_of_Faces_by_Material.main }
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #
module SDM

	module Area_of_Faces_by_Material
	
		def self.main
			mod=Sketchup.active_model;
			ent=mod.active_entities;
			sel=mod.selection
			@mats=mod.materials.map{|m|m.name}
			@mat ||= @mats[0]
			values = UI.inputbox(['Material:'],[@mat],[@mats.join('|')],'Pick Material')
			if values
				@mat = values[0]
				sel.empty? ? ents=ent.to_a : ents=sel.to_a
				@xscl = @yscl = @zscl = 1.0
				@tot_area = 0.0; self.find_faces(ents)
				UI.messagebox "Total area of faces with material #{@mat} = #{Sketchup.format_area(@tot_area)}"
				# puts "Total area = #{Sketchup.format_area(@tot_area)}"
			end
		end
		
		def self.find_faces(ents)
			for e in ents
				if e.is_a?(Sketchup::Face) && e.material==Sketchup.active_model.materials[@mat]
					if @xscl*@yscl*@zscl == 1.0
						@tot_area += e.area
					else
						nrm = e.normal
						for loop in e.loops
							pts = loop.vertices.map{|v|v.position}
							for p in pts
								p.x *= @xscl
								p.y *= @yscl
								p.z *= @zscl
							end
							if loop.outer?
								@tot_area += self.area_of_polygon(pts)
							else
								@tot_area -= self.area_of_polygon(pts)
							end
						end
					end
				elsif e.is_a? Sketchup::Group
					@xscl = e.transformation.xscale; @yscl = e.transformation.yscale; @zscl = e.transformation.zscale
					self.find_faces(e.entities)
				elsif e.is_a? Sketchup::ComponentInstance
					@xscl = e.transformation.xscale; @yscl = e.transformation.yscale; @zscl = e.transformation.zscale
					self.find_faces(e.definition.entities)
				end
			end
		end

		def self.area_of_polygon(pts)
			aop=0.0;	n = Geom.fit_plane_to_points(pts); 
			norm = Geom::Vector3d.new(n.x,n.y,n.z)
			xa = norm.axes[0]; ang = norm.angle_between(Z_AXIS)
			tr = Geom::Transformation.rotation(pts[0],xa,-ang)
			pts.each{|p|p.transform!(tr)};#rotate points to XY plane
			for i in  0...pts.length
				aop += (pts[i-1].x * pts[i].y - pts[i].x * pts[i-1].y)
			end
			return aop.abs / 2.0
		end
	
	end
	
end
